//---------------------------------------------------------------------------
#include <vcl.h>
#include "FileCtrl.hpp"
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
AnsiString Dir;         //  
TListItem *Selected;    //  
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
//    
Dir = "E:\\Games";
 if (Dir[Dir.Length()] != '\\')
   Dir = Dir + "\\";
 Find();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
//  
 SelectDirectory(" ", "", Dir);
 if (Dir[Dir.Length()] != '\\')
   Dir = Dir + "\\";
 Find();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
ListView1->ViewStyle = vsIcon;  //  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListView1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
//   
Selected = ListView1->GetItemAt(X, Y);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListView1DblClick(TObject *Sender)
{
//    
  if (Selected)
  {
    ShellExecute(Handle, "open", Selected->Caption.c_str(), NULL, NULL, SW_SHOW);
  }
}
//===========================================================================
//=====FIND==================================================================
//===========================================================================
void __fastcall TForm1::Find(void)
{
ListView1->Items->BeginUpdate();        //  
ListView1->Items->Clear();              // 
StaticText1->Caption = Dir;
ViewDir();                              //   
ListView1->Items->EndUpdate();
}
//===========================================================================
//====VIEW DIR===============================================================
//===========================================================================
void __fastcall TForm1::ViewDir(void)
{
//   
TSearchRec SR;
int ires, TBegin;
TListItem *NewItem;
TSHFileInfo FileInfo;

TIcon *Icon = new TIcon;

Form1->ImageListIcon->Clear();
Form1->ImageListIcon->AddIcon(Icon);

ChDir(Dir);  //  

//  
ires = FindFirst("*.*", faHidden+faSysFile, SR);
 while (ires == 0)
 {
  if ((SR.Name != ".") && (SR.Name != ".."))
  {
    AnsiString FName;
    //    
    NewItem = Form1->ListView1->Items->Add();
    FName = SR.Name;
    NewItem->Caption = FName.SubString(0,FName.Length()-4);
    //  
    SHGetFileInfo((Dir + SR.Name).c_str(), 0, &FileInfo, sizeof(FileInfo), SHGFI_ICON | SHGFI_LARGEICON);
    Icon->Handle = FileInfo.hIcon;
    Form1->ImageListIcon->AddIcon(Icon);
    NewItem->ImageIndex = Form1->ImageListIcon->Count-1;
    //    
    NewItem->OverlayIndex = 1;
  }
  //  
  ires = FindNext(SR);
 }
//   
FindClose(SR);
}
//---------------------------------------------------------------------------

